unit UnidadMenuPrincipal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, shellapi, ExtCtrls;

type
  TformMenuPrincipal = class(TForm)
    bExtraer: TBitBtn;
    bCerrar: TBitBtn;
    Image1: TImage;
    Panel1: TPanel;
    dlAbrir: TOpenDialog;
    dlGuardar: TSaveDialog;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    txtEjecutable: TEdit;
    Label2: TLabel;
    txtDestino: TEdit;
    bSelFichero: TBitBtn;
    BitBtn1: TBitBtn;
    Label3: TLabel;
    procedure bExtraerClick(Sender: TObject);
    procedure bCerrarClick(Sender: TObject);
    procedure txtEjecutableChange(Sender: TObject);
    procedure bSelFicheroClick(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formMenuPrincipal: TformMenuPrincipal;

implementation

{$R *.dfm}

procedure TformMenuPrincipal.bExtraerClick(Sender: TObject);
var
  IconIndex: word;
  Buffer: array[0..2048] of char;
  Icono: TIcon;
begin
  if (txtEjecutable.Text = '') or (txtDestino.Text = '') then
  begin
    MessageDlg('Debe indicar el fichero origen y el icono de destino.',
        mtInformation, [mbok], 0);
    txtEjecutable.SetFocus;
  end
  else
  begin
    Icono := Ticon.create;
    StrCopy(@Buffer, pchar(txtEjecutable.Text));
    IconIndex := 0;
    Icono.Handle := ExtractAssociatedIcon(HInstance, Buffer, IconIndex);
    if Icono.Handle <> 0 then
    begin
      Image1.Picture.Icon := Icono;
      Image1.Picture.SaveToFile(txtDestino.Text);
    end;
  end

{  StrCopy(@Buffer, pchar(txtEjecutable.Text));
  IconIndex := 0;
  IconHandle := ExtractAssociatedIcon(HInstance, Buffer, IconIndex);
  if IconHandle <> 0 then
    Icon.Handle := IconHandle;}
end;

procedure TformMenuPrincipal.bCerrarClick(Sender: TObject);
begin
  close;
end;

procedure TformMenuPrincipal.txtEjecutableChange(Sender: TObject);
begin
  txtDestino.Text := ExtractFilePath (txtEjecutable.Text) +
      ChangeFileExt (ExtractFileName (txtEjecutable.Text), '.ico');
end;

procedure TformMenuPrincipal.bSelFicheroClick(Sender: TObject);
begin
  if dlAbrir.Execute then
    txtEjecutable.Text := dlAbrir.FileName;
end;

procedure TformMenuPrincipal.BitBtn1Click(Sender: TObject);
begin
  if dlGuardar.Execute then
    txtDestino.Text := dlGuardar.FileName;
end;

end.
